/***********************************************************************************************************************
 *
 * blueBill Stats
 * Copyright (C) 2011-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile/
 * SCM: http://java.net/hg/bluebill-server~stats-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.stats.domain;

import javax.annotation.concurrent.Immutable;
import org.joda.time.DateTime;
import lombok.Getter;
import lombok.RequiredArgsConstructor;
import lombok.ToString;
import static lombok.AccessLevel.*;

/***********************************************************************************************************************
 *
 * A {@code Ping} is a bag of data sent by the mobile app sometimes when it starts.
 * 
 * @stereotype Datum
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@Immutable @RequiredArgsConstructor @ToString @Getter(PUBLIC) // FIXME: public because of BeanItem
public class Ping 
  {
    private final DateTime timestamp;
    
    private final String ipAddress;
    
    private final String installId;
    
    private final String appVersion;

    private final String osVersion;
    
    private final String javaVersion;
    
    private final String userLanguage;
    
    private final String userRegion;
    
    private final String board;
    
    private final String brand;
    
    private final String device;
    
    private final String model;
    
    private final String product;
    
    private final String versionIncremental;
    
    private final String versionRelease;
    
    private final String versionSDK;
  }
