/***********************************************************************************************************************
 *
 * blueBill Stats
 * Copyright (C) 2011-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it/mobile/
 * SCM: http://java.net/hg/bluebill-server~stats-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.stats.domain;

import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * This class is the DAO for {@link Ping}.
 * 
 * @stereotype DAO
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public interface PingDao
  {
    /*******************************************************************************************************************
     *
     * Creates a {@link Finder} for {@code Ping}s.
     *
     ******************************************************************************************************************/
    @Nonnull
    public PingFinder findPings();
    
    /*******************************************************************************************************************
     *
     * Inserts a {@code Ping} into the persistence facility.
     * 
     * @param  ping  the {@code Ping} to insert
     *
     ******************************************************************************************************************/
    public void insert (@Nonnull Ping ping);
  }
